(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('micro-dash')) :
    typeof define === 'function' && define.amd ? define('s-rxjs-utils', ['exports', 'rxjs', 'rxjs/operators', 'micro-dash'], factory) :
    (global = global || self, factory(global['s-rxjs-utils'] = {}, global.rxjs, global.rxjs.operators, global.microDash));
}(this, function (exports, rxjs, operators, microDash) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 1. Caches the last value emitted to give to new subscribers (without running any upstream pipe operators)
     * 2. Manages all subscribers directly, without passing subscriptions up the stream.
     *
     * This is very similar to `shareReplay(1)`, except that once all subscribers unsubscribe this also unsubscribes from the upstream observable.
     *
     * ```ts
     * const source = new BehaviorSubject(1000);
     * const result = source.pipe(expensiveComputation(), cache());
     * source.subscribe(); // expensiveComputation(1000) runs
     * source.subscribe(); // the cached result is used
     * source.next(2000); // expensiveComputation(2000) runs once, emitted to both subscribers
     * ```
     * @template T
     * @return {?}
     */
    function cache() {
        return (/**
         * @param {?} source
         * @return {?}
         */
        function (source) {
            /** @type {?} */
            var middleMan;
            /** @type {?} */
            var upstreamSubscription;
            return new rxjs.Observable((/**
             * @param {?} subscriber
             * @return {?}
             */
            function (subscriber) {
                if (!middleMan) {
                    middleMan = new rxjs.ReplaySubject(1);
                    upstreamSubscription = source.subscribe(middleMan);
                }
                /** @type {?} */
                var subscription = middleMan.subscribe(subscriber);
                // teardown logic
                return (/**
                 * @return {?}
                 */
                function () {
                    subscription.unsubscribe();
                    if (middleMan && middleMan.observers.length === 0) {
                        upstreamSubscription.unsubscribe();
                        middleMan = undefined;
                    }
                });
            }));
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Delays the emission of items from the source Observable using the microtask queue.
     * @template T
     * @return {?}
     */
    function delayOnMicrotaskQueue() {
        return operators.delay(0, rxjs.asapScheduler);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @hidden
     * @param {?} set
     * @param {?} subset
     * @return {?}
     */
    function isSuperset(set, subset) {
        var e_1, _a;
        try {
            for (var subset_1 = __values(subset), subset_1_1 = subset_1.next(); !subset_1_1.done; subset_1_1 = subset_1.next()) {
                var elem = subset_1_1.value;
                if (!set.has(elem)) {
                    return false;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (subset_1_1 && !subset_1_1.done && (_a = subset_1.return)) _a.call(subset_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @hidden
     * @param {?} setA
     * @param {?} setB
     * @return {?}
     */
    function isSetEqual(setA, setB) {
        return setA.size === setB.size && isSuperset(setA, setB);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Allows items through whose keys are distinct from the previous item.
     *
     * ```
     * source:                     |-{a:1,b:2}--{a:2,b:3}--{a:2,c:3}--{b:3}--{b:4}-|
     * distinctUntilKeysChanged(): |-{a:1,b:2}-------------{a:2,c:3}--{b:3}--------|
     * ```
     * @template T
     * @return {?}
     */
    function distinctUntilKeysChanged() {
        /** @type {?} */
        var lastKeySet;
        return operators.filter((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var keySet = new Set(microDash.keys(value));
            if (lastKeySet && isSetEqual(keySet, lastKeySet)) {
                return false;
            }
            lastKeySet = keySet;
            return true;
        }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Use this to create a complex pipeable operator. It is usually better style to compose existing operators than to create a brand new one, but when you need full control this can reduce some boilerplate.
     *
     * The supplied `subscriber` will act as a simple pass-through of all values, errors, and completion to `destination`. Modify it for your needs.
     *
     * A simple example, recreating the "map" operator:
     * ```ts
     * function map<I, O>(fn: (input: I) => O) {
     *   return createOperatorFunction<I, O>(
     *     (subscriber, destination) => {
     *       subscriber.next = (value) => {
     *         destination.next(fn(value));
     *       };
     *     },
     *   );
     * }
     * ```
     *
     * For a more complex example, check the source of `skipAfter`.
     * @template SourceType, DestinationType
     * @param {?} modifySubscriber
     * @return {?}
     */
    function createOperatorFunction(modifySubscriber) {
        return (/**
         * @param {?} source
         * @return {?}
         */
        function (source) {
            return new rxjs.Observable((/**
             * @param {?} destination
             * @return {?}
             */
            function (destination) {
                /** @type {?} */
                var subscriber = new rxjs.Subscriber(destination);
                modifySubscriber(subscriber, destination);
                return source.subscribe(subscriber);
            }));
        });
    }
    /**
     * @record
     * @template T
     */
    function RequiredSubscriber() { }
    if (false) {
        /**
         * `value` is optional in `Subscriber`. We need it to be required.
         * @param {?} value
         * @return {?}
         */
        RequiredSubscriber.prototype.next = function (value) { };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Works like `filter()`, but always lets through the first emission for each new subscriber. This makes it suitable for subscribers that expect the observable to behave like a `BehaviorSubject`, where the first emission is processed synchronously during the call to `subscribe()` (such as the `async` pipe in an Angular template).
     *
     * ```
     * source:                   |-false--true--false--true--false--true-|
     * filterBehavior(identity): |-false--true---------true---------true-|
     * filterBehavior(identity):        |-true---------true---------true-|
     * filterBehavior(identity):              |-false--true---------true-|
     * ```
     * @template T
     * @param {?} predicate
     * @return {?}
     */
    function filterBehavior(predicate) {
        return createOperatorFunction((/**
         * @param {?} subscriber
         * @param {?} destination
         * @return {?}
         */
        function (subscriber, destination) {
            /** @type {?} */
            var firstValue = true;
            subscriber.next = (/**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (firstValue) {
                    destination.next(value);
                    firstValue = false;
                    return;
                }
                try {
                    if (predicate(value)) {
                        destination.next(value);
                    }
                }
                catch (ex) {
                    destination.error(ex);
                }
            });
        }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Logs values, errors and completion to the console, and passes them all along unchanged.
     *
     * ```ts
     * of(1, 2).pipe(logValues()).subscribe();
     * // prints using console.log:
     * // [value] 1
     * // [value] 2
     * // [complete]
     *
     * of(1, 2).pipe(logValues("my number", "debug")).subscribe();
     * // prints using console.debug:
     * // [value] my number 1
     * // [value] my number 2
     * // [complete] my number
     *
     * throwError("boo").pipe(logValues("pipe says", "warn")).subscribe();
     * // prints using console.warn:
     * // [error] pipe says boo
     * ```
     * @template T
     * @param {?=} prefix
     * @param {?=} level
     * @return {?}
     */
    function logValues(prefix, level) {
        if (level === void 0) { level = "log"; }
        return operators.tap(makeLogFn("[value]"), makeLogFn("[error]"), makeLogFn("[complete]"));
        /**
         * @param {...?} prefixes
         * @return {?}
         */
        function makeLogFn() {
            var prefixes = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                prefixes[_i] = arguments[_i];
            }
            if (prefix !== undefined) {
                prefixes.push(prefix);
            }
            return (/**
             * @param {...?} values
             * @return {?}
             */
            function () {
                var values = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    values[_i] = arguments[_i];
                }
                console[level].apply(console, __spread(prefixes, values));
            });
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @hidden
     * @template UpstreamType, DownstreamType
     * @param {?} buildCacheKey
     * @param {?} buildDownstreamItem
     * @return {?}
     */
    function mapAndCacheElements(buildCacheKey, buildDownstreamItem) {
        /** @type {?} */
        var cache = new Map();
        return operators.map((/**
         * @param {?} upstreamItems
         * @return {?}
         */
        function (upstreamItems) {
            /** @type {?} */
            var nextCache = new Map();
            /** @type {?} */
            var downstreamItems = microDash.map(upstreamItems, (/**
             * @param {?} upstreamItem
             * @param {?} key
             * @return {?}
             */
            function (upstreamItem, key) {
                /** @type {?} */
                var cacheKey = buildCacheKey(upstreamItem, key);
                /** @type {?} */
                var downstreamItem;
                if (cache.has(cacheKey)) {
                    downstreamItem = (/** @type {?} */ (cache.get(cacheKey)));
                }
                else if (nextCache.has(cacheKey)) {
                    downstreamItem = (/** @type {?} */ (nextCache.get(cacheKey)));
                }
                else {
                    downstreamItem = buildDownstreamItem(upstreamItem, key);
                }
                nextCache.set(cacheKey, downstreamItem);
                return downstreamItem;
            }));
            cache = nextCache;
            return downstreamItems;
        }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Applies `buildDownstreamItem` to each item in the upstream array and emits the result. Each downstream item is cached using the key generated by `buildCacheKey` so that the next emission contains references to the matching objects from the previous emission, without running `buildDownstreamItem` again. The cache is only held between successive emissions.
     *
     * This is useful e.g. when using the result in an `*ngFor` expression of an angular template, to prevent angular from rebuilding the inner component and to allow `OnPush` optimizations in the inner component.
     *
     * If multiple items in an upstream array have the same cache key, it will only call `buildDownstreamItem` once.
     *
     * ```ts
     * const mapWithCaching = mapAndCacheArrayElements(
     *   (item) => item,
     *   (item) => item + 1
     * )
     * ```
     * ```
     * source:         -[1, 2]---[1, 2, 3]---[2]--|
     * mapWithCaching: -[2, 3]---[2, 3, 4]---[3]--|
     * ```
     * @type {?}
     */
    var mapAndCacheArrayElements = (/** @type {?} */ (mapAndCacheElements));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Applies `buildDownstreamItem` to each item in the upstream object and emits an array containing the results. Each downstream item is cached using the key generated by `buildCacheKey` so that the next emission contains references to the matching objects from the previous emission, without running `buildDownstreamItem` again. The cache is only held between successive emissions.
     *
     * This is useful e.g. when using the result in an `*ngFor` expression of an angular template, to prevent angular from rebuilding the inner component and to allow `OnPush` optimizations in the inner component.
     *
     * If multiple items in an upstream object have the same cache key, it will only call `buildDownstreamItem` once.
     *
     * ```ts
     * const mapWithCaching = mapAndCacheObjectElements(
     *   (item, key) => key,
     *   (item, key) => item + 1
     * )
     * ```
     * ```
     * source:         -{ a: 1, b: 2 }---{ a: 1, b: 2, c: 3 }---{ b: 2 }--|
     * mapWithCaching: -[2, 3]-----------[2, 3, 4]--------------[3]--|
     * ```
     * @type {?}
     */
    var mapAndCacheObjectElements = (/** @type {?} */ (mapAndCacheElements));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Emits the latest value of the given Observable every time the source Observable emits a value.
     *
     * ```
     * source:               -1---2--3------4-|
     * inner:                ---a------b--c---|
     * mapToLastFrom(inner): -----a--a------c-|
     * ```
     * @template T
     * @param {?} inner$
     * @return {?}
     */
    function mapToLatestFrom(inner$) {
        return microDash.flow(operators.withLatestFrom(inner$), operators.map((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 2), _ = _b[0], inner = _b[1];
            return inner;
        })));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Causes the next value in the pipe to be skipped after `skip$` emits a value. For example:
     *
     * ```
     * source: -1-----2-----3-----4-----5-|
     * skip$:  ----0----------0-0----------
     *
     * result: -1-----------3-----------5-|
     * ```
     * ```ts
     * const source = new Subject();
     * const skip$ = new Subject();
     * const result = source.pipe(skipAfter(skip$));
     *
     * source.next(1); // result emits `1`
     *
     * skip$.next();
     * source.next(2); // result does not emit
     * source.next(3); // result emits `3`
     *
     * skip$.next();
     * skip$.next();
     * source.next(4); // result does not emit
     * source.next(5); // result emits `5`
     * ```
     * @template T
     * @param {?} skip$
     * @return {?}
     */
    function skipAfter(skip$) {
        return createOperatorFunction((/**
         * @param {?} subscriber
         * @param {?} destination
         * @return {?}
         */
        function (subscriber, destination) {
            /** @type {?} */
            var skipNext = false;
            subscriber.add(skip$.subscribe((/**
             * @return {?}
             */
            function () {
                skipNext = true;
            }), microDash.bindKey(destination, "error")));
            subscriber.next = (/**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (skipNext) {
                    skipNext = false;
                }
                else {
                    destination.next(value);
                }
            });
        }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Emits the upstream value as the first element in an array, followed by the last `count` values in reverse chronological order.
     *
     * ```
     * source:         -1----2------3--------4--------5--------|
     * withHistory(2): -[1]--[2,1]--[3,2,1]--[4,3,2]--[5,4,3]--|
     * withHistory(0): -[1]--[2]----[3]------[4]------[5]------|
     * ```
     * @template T
     * @param {?} count
     * @return {?}
     */
    function withHistory(count) {
        return operators.scan((/**
         * @param {?} buf
         * @param {?} value
         * @return {?}
         */
        function (buf, value) { return __spread([value], buf.slice(0, count)); }), []);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Tracks all subscriptions to easily unsubscribe from them all during cleanup. Also binds callbacks to `this` for convenient use as a superclass, e.g.:
     *
     * ```ts
     * class EventLogger extends SubscriptionManager {
     *   constructor(private prefix: string, event$: Observable<string>) {
     *     super();
     *
     *     // you can pass in an instance method here and it will be bound to `this`
     *     this.subscribeTo(event$, this.log);
     *   }
     *
     *   log(event: string) {
     *     // even though this is used as a callback, you can still use `this`
     *     console.log(this.prefix + event);
     *   }
     * }
     * ```
     */
    var   /**
     * Tracks all subscriptions to easily unsubscribe from them all during cleanup. Also binds callbacks to `this` for convenient use as a superclass, e.g.:
     *
     * ```ts
     * class EventLogger extends SubscriptionManager {
     *   constructor(private prefix: string, event$: Observable<string>) {
     *     super();
     *
     *     // you can pass in an instance method here and it will be bound to `this`
     *     this.subscribeTo(event$, this.log);
     *   }
     *
     *   log(event: string) {
     *     // even though this is used as a callback, you can still use `this`
     *     console.log(this.prefix + event);
     *   }
     * }
     * ```
     */
    SubscriptionManager = /** @class */ (function () {
        function SubscriptionManager() {
            this.subscriptions = new rxjs.Subscription();
        }
        /**
         * @template T
         * @param {?} observable
         * @param {?=} next
         * @param {?=} error
         * @param {?=} complete
         * @return {?}
         */
        SubscriptionManager.prototype.subscribeTo = /**
         * @template T
         * @param {?} observable
         * @param {?=} next
         * @param {?=} error
         * @param {?=} complete
         * @return {?}
         */
        function (observable, next, error, complete) {
            this.subscriptions.add(observable.subscribe(this.bind(next), this.bind(error), this.bind(complete)));
        };
        /**
         * @return {?}
         */
        SubscriptionManager.prototype.unsubscribe = /**
         * @return {?}
         */
        function () {
            this.subscriptions.unsubscribe();
            this.subscriptions = new rxjs.Subscription();
        };
        /**
         * @private
         * @param {?=} fn
         * @return {?}
         */
        SubscriptionManager.prototype.bind = /**
         * @private
         * @param {?=} fn
         * @return {?}
         */
        function (fn) {
            return fn && fn.bind(this);
        };
        return SubscriptionManager;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        SubscriptionManager.prototype.subscriptions;
    }

    exports.SubscriptionManager = SubscriptionManager;
    exports.cache = cache;
    exports.createOperatorFunction = createOperatorFunction;
    exports.delayOnMicrotaskQueue = delayOnMicrotaskQueue;
    exports.distinctUntilKeysChanged = distinctUntilKeysChanged;
    exports.filterBehavior = filterBehavior;
    exports.logValues = logValues;
    exports.mapAndCacheArrayElements = mapAndCacheArrayElements;
    exports.mapAndCacheObjectElements = mapAndCacheObjectElements;
    exports.mapToLatestFrom = mapToLatestFrom;
    exports.skipAfter = skipAfter;
    exports.withHistory = withHistory;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=s-rxjs-utils.umd.js.map
